/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * at51db.h		device data base!
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _at51db_h_at51tool
#define _at51db_h_at51tool

#include "at51table.h"

static at51_table_t at51_db[] = {
    {
	"AT89C1051","Atmel",
	_Yes,"test device, check and verify id",
	_Yes,"read device memory",
	_Yes,"write and verify device memory",
	_Yes,"burn and not verify device memory",
	_Yes,"erase device memory",
	_Yes,"lock device memory level 1",
	_Yes,"lock device memory level 2",
	_No,"lock level 3 not exist",
	_No,"lock level 4 not exist",
	_No,"read lock not available"
    },
    {
	"AT89C2051","Atmel",
	_Yes,"test device, check and verify id",
	_Yes,"read device memory",
	_Yes,"write and verify device memory",
	_Yes,"burn and not verify device memory",
	_Yes,"erase device memory",
	_Yes,"lock device memory level 1",
	_Yes,"lock device memory level 2",
	_No,"lock level 3 not exist",
	_No,"lock level 4 not exist",
	_No,"read lock not available"
    },
    {
	"AT89C4051","Atmel",
	_Yes,"test device, check and verify id",
	_Yes,"read device memory",
	_Yes,"write and verify device memory",
	_Yes,"burn and not verify device memory",
	_Yes,"erase device memory",
	_Yes,"lock device memory level 1",
	_Yes,"lock device memory level 2",
	_No,"lock level 3 not exist",
	_No,"lock level 4 not exist",
	_No,"read lock not available"
    },
    {
	"AT89C51","Atmel",
	_Yes,"test device, check and verify id",
	_Yes,"read device memory",
	_Yes,"write and verify device memory",
	_Yes,"burn and not verify device memory",
	_Yes,"erase device memory",
	_Yes,"lock device memory level 1",
	_Yes,"lock device memory level 2",
	_Yes,"lock device memory level 3",
	_No,"lock level 4 not exist",
	_No,"read lock not available"
    },
    {
	"AT89C52","Atmel",
	_Yes,"test device, check and verify id",
	_Yes,"read device memory",
	_Yes,"write and verify device memory",
	_Yes,"burn and not verify device memory",
	_Yes,"erase device memory",
	_Yes,"lock device memory level 1",
	_Yes,"lock device memory level 2",
	_Yes,"lock device memory level 3",
	_No,"lock level 4 not exist",
	_No,"read lock not available"
    },
    {
	"AT89S51","Atmel",
	_Yes,"test device, check and verify id",
	_Yes,"read device memory",
	_Yes,"write and verify device memory",
	_Yes,"burn and not verify device memory",
	_Yes,"erase device memory",
	_Yes,"lock device memory level 1",
	_Yes,"lock device memory level 2",
	_Yes,"lock device memory level 3",
	_No,"lock level 4 not exist",
	_Yes,"read device memory lock bits"
    },
    {
	"AT89S52","Atmel",
	_Yes,"test device, check and verify id",
	_Yes,"read device memory",
	_Yes,"write and verify device memory",
	_Yes,"burn and not verify device memory",
	_Yes,"erase device memory",
	_Yes,"lock device memory level 1",
	_Yes,"lock device memory level 2",
	_Yes,"lock device memory level 3",
	_No,"lock level 4 not exist",
	_Yes,"read device memory lock bits"
    },
    {
	"","",
	_No,"",
	_No,"",
	_No,"",
	_No,"",
	_No,"",
	_No,"",
	_No,"",
	_No,"",
	_No,"",
	_No,""
    }
};

#endif

/* end of at51db.h */
