/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * at51decision.h	general decisions
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _at51decision_h_at51tool
#define _at51decision_h_at51tool

#include <string.h>

#include "version.h"
#include "at51defs.h"
#include "at51param.h"
#include "at51db.h"
#include "at51disc.h"

#include "at89s51.h"
#include "at89s52.h"
#include "at89c51.h"
#include "at89c52.h"
#include "at89c1051.h"
#include "at89c2051.h"
#include "at89c4051.h"

int at51_dec_check_command_compillance(at51_param_t *at51_param);
int at51_dec_lookup_partindex(at51_param_t *at51_param);
int at51_dec_process_device_command(at51_param_t *at51_param,
			    int *dec_error, int *dec_status);

int at51_dec_process_device_AT89S51_command(at51_param_t *at51_param,
			    int *dec_error, int *dec_status);
int at51_dec_process_device_AT89S52_command(at51_param_t *at51_param,
			    int *dec_error, int *dec_status);
int at51_dec_process_device_AT89C51_command(at51_param_t *at51_param,
			    int *dec_error, int *dec_status);
int at51_dec_process_device_AT89C52_command(at51_param_t *at51_param,
			    int *dec_error, int *dec_status);
int at51_dec_process_device_AT89C1051_command(at51_param_t *at51_param,
			    int *dec_error, int *dec_status);
int at51_dec_process_device_AT89C2051_command(at51_param_t *at51_param,
			    int *dec_error, int *dec_status);
int at51_dec_process_device_AT89C4051_command(at51_param_t *at51_param,
			    int *dec_error, int *dec_status);

#endif

/* end of at51decision.h */
