/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * at51disc.h		disc save / load
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _at51disc_h_at51tool
#define _at51disc_h_at51tool

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

#include "at51defs.h"
#include "at51status.h"

#include "at51param.h"

int at51_disc_save_buffer(at51_param_t *at51_param,
			    int *disc_error, int *disc_status);
int at51_disc_load_buffer(at51_param_t *at51_param,
			    int *disc_error, int *disc_status);

#endif

/* end of at51disc.h */
