/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * at51help.h		help routines
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _at51help_h_at51tool
#define _at51help_h_at51tool

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "at51defs.h"
#include "at51param.h"
#include "version.h"
#include "at51db.h"

int at51_help_show_help_full(at51_param_t *at51_param);
int at51_help_show_help_intro(at51_param_t *at51_param);
int at51_help_show_help_basic(at51_param_t *at51_param);
int at51_help_show_help_part(at51_param_t *at51_param);
int at51_help_show_help_command(at51_param_t *at51_param);
int at51_help_show_help_part_and_command(at51_param_t *at51_param);
int at51_help_show_help_compillance(at51_param_t *at51_param);
int at51_help_show_help_device_isnt_supported(at51_param_t *at51_param);

int at51_help_show_list_supported_devices(at51_param_t *at51_param);
int at51_help_show_list_supported_commands(at51_param_t *at51_param);

#endif

/* end of at51help.h */
