/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * at51param.h		at51param struct definition
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _at51param_h_at51tool
#define _at51param_h_at51tool

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <termios.h>

#include "at51defs.h"
#include "at51status.h"

typedef struct {
    char partname[32];
    int command;
    char forcedcommand;
    unsigned char showhelp;
    unsigned char showlist;
    int partindex;
    char filename[256];
    unsigned char *buffer;
    int buffersize;
    int serial_fd;
    struct termios oldtio;
    struct termios newtio;
} at51_param_t;

int at51_param_init_struct(at51_param_t *at51_param, 
			    int *param_error, int *param_status);

int at51_param_finalize_struct(at51_param_t *at51_param, 
			    int *param_error, int *param_status);

#endif

/* end of at51param.h */
