/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * at51status.h		status codes used from the most functions
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _at51status_h_at51tool
#define _at51status_h_at51tool

#define _S_PARAM_OKINITIALIZATION		101
#define _S_PARAM_OKFINALIZATION			102
#define _S_PARAM_ERRORINVALIDSTRUCT		151
#define _S_PARAM_ERRORALLOCATEMEMORY		152
#define _S_PARAM_ERROROPENSERIALPORT		153

#define _S_DISC_OKWRITEFILE			201
#define _S_DISC_ERRORCREATEFILE			251
#define _S_DISC_ERRORWRITEFILE			252
#define _S_DISC_ERROROPENFILE			253
#define _S_DISC_ERRORREADFILE			254
#define _S_DISC_ERRORINVALIDREQUEST		255

#define _S_PRO_OKGETID				301
#define _S_PRO_OKREAD				302
#define _S_PRO_OKWRITE				303
#define _S_PRO_OKERASE				304
#define _S_PRO_OKLOCK1				305
#define _S_PRO_OKLOCK2				306
#define _S_PRO_OKLOCK3				307
#define _S_PRO_OKREADLOCK			308
#define _S_PRO_OKDEVICELOCKED			309
#define _S_PRO_ERRORINVALIDREQUEST		351
#define _S_PRO_ERRORWRITINGDEVICE		352

#define _S_DEC_OKDEVICEPROCESSED		401
#define _S_DEC_ERRORNOSPECIFIEDDEVICE		451
#define _S_DEC_ERRORUNSUPPORTEDDEVICE		452
#define _S_DEC_ERRORNOSPECIFIEDCOMMAND		453
#define _S_DEC_ERRORUNDERCONSTRUCTION		454
#define _S_DEC_ERRORDEVICENOTFOUNDORDIFFERENT	455
#define _S_DEC_ERRORWRITINGDEVICE		456
#define _S_DEC_ERRORWRITINGUNKNOWN		457

#endif

/* end of at51status.h */
