/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * at89c1051.h		AT89C1051 programming functions
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _at89c1051_h_at51tool
#define _at89c1051_h_at51tool

#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>

#include "gpios.h"
#include "b2051pinbind.h"

#include "at51defs.h"

#include "at51param.h"

int at51_at89c1051_test (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89c1051_read (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89c1051_erase (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89c1051_write (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89c1051_burn (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89c1051_lock1 (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89c1051_lock2 (at51_param_t *at51_param, int *pro_error, int *pro_status);

#endif

/* end of at89c1051.h */
