/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * at89s52.h		AT89S52 programming functions
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _at89s52_h_at51tool
#define _at89s52_h_at51tool

#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>

#include "gpios.h"
#include "b8051pinbind.h"

#include "at51param.h"

int at51_at89s52_test (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89s52_read (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89s52_erase (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89s52_write (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89s52_burn (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89s52_lock1 (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89s52_lock2 (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89s52_lock3 (at51_param_t *at51_param, int *pro_error, int *pro_status);
int at51_at89s52_readlock (at51_param_t *at51_param, int *pro_error, int *pro_status);

#endif

/* end of at89s52.h */
