/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * b2051pinbind.c	2051 pin binding subLayer
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#include "b2051pinbind.h"

/*---------------------------------------------------------------------------*/
void at51_board2051_ActivityLED_On(int fsd) {
    clear_s_p24(fsd);
}
void at51_board2051_ActivityLED_Off(int fsd) {
    set_s_p24(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Power33_On(int fsd) {
    clear_s_p17(fsd);
}
void at51_board2051_Power33_Off(int fsd) {
    set_s_p17(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Power5_On(int fsd) {
    clear_s_p16(fsd);
}
void at51_board2051_Power5_Off(int fsd) {
    set_s_p16(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Power65_On(int fsd) {
    clear_s_p21(fsd);
}
void at51_board2051_Power65_Off(int fsd) {
    set_s_p21(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Power_Off(int fsd) {
    set_s_p17(fsd);
    set_s_p16(fsd);
    set_s_p21(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Prog33_On(int fsd) {
    clear_s_p20(fsd);
}
void at51_board2051_Prog33_Off(int fsd) {
    set_s_p20(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Prog5_On(int fsd) {
    clear_s_p23(fsd);
}
void at51_board2051_Prog5_Off(int fsd) {
    set_s_p23(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Prog75_On(int fsd) {
    clear_s_p22(fsd);
}
void at51_board2051_Prog75_Off(int fsd) {
    set_s_p22(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Prog12_On(int fsd) {
    clear_s_p25(fsd);
}
void at51_board2051_Prog12_Off(int fsd) {
    set_s_p25(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Prog_Off(int fsd) {
    set_s_p20(fsd);
    set_s_p23(fsd);
    set_s_p22(fsd);
    set_s_p25(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_SendData(int fsd, unsigned char xdata) {
    send_m_p1(fsd,xdata);
}
/*---------------------------------------------------------------------------*/
unsigned char at51_board2051_ReceiveData(int fsd) {
    return receive_m_p1(fsd);
}
/*---------------------------------------------------------------------------*/
unsigned char at51_board2051_Get_RDY(int fsd) {
    return get_m_p36(fsd);
}
unsigned char at51_board2051_Get_P31(int fsd) {
    return get_m_p36(fsd);
}
void at51_board2051_Send_RDY(int fsd, int xdata) {
    if (xdata) set_m_p36(fsd);
    else clear_m_p36(fsd);
}
void at51_board2051_Send_P31(int fsd, int xdata) {
    if (xdata) set_m_p36(fsd);
    else clear_m_p36(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Send_PROG(int fsd, int xdata) {
    if (xdata) set_s_p10(fsd);
    else clear_s_p10(fsd);
}
void at51_board2051_Send_P32(int fsd, int xdata) {
    if (xdata) set_s_p10(fsd);
    else clear_s_p10(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Send_XTAL(int fsd, int xdata) {
    if (xdata) set_s_p11(fsd);
    else clear_s_p11(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Send_P33(int fsd, int xdata) {
    if (xdata) set_s_p13(fsd);
    else clear_s_p13(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Send_P34(int fsd, int xdata) {
    if (xdata) set_s_p12(fsd);
    else clear_s_p12(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Send_P35(int fsd, int xdata) {
    if (xdata) set_s_p15(fsd);
    else clear_s_p15(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board2051_Send_P37(int fsd, int xdata) {
    if (xdata) set_s_p14(fsd);
    else clear_s_p14(fsd);
}
/*---------------------------------------------------------------------------*/

/* end of b2051pinbind.c */
