/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * b2051pinbind.h	2051 pin binding subLayer
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _b2051pinbind_h_at51tool
#define _b2051pinbind_h_at51tool

#include "gpios.h"

#define _at51_board2051_ActivityLED_On(fsd)		clear_s_p24(fsd)
#define _at51_board2051_ActivityLED_Off(fsd)		set_s_p24(fsd)
#define _at51_board2051_Power33_On(fsd)			clear_s_p17(fsd)
#define _at51_board2051_Power33_Off(fsd)		set_s_p17(fsd)
#define _at51_board2051_Power5_On(fsd)			clear_s_p16(fsd)
#define _at51_board2051_Power5_Off(fsd)			set_s_p16(fsd)
#define _at51_board2051_Power65_On(fsd)			clear_s_p21(fsd)
#define _at51_board2051_Power65_Off(fsd)		set_s_p21(fsd)
#define _at51_board2051_Prog33_On(fsd)			clear_s_p20(fsd)
#define _at51_board2051_Prog33_Off(fsd)			set_s_p20(fsd)
#define _at51_board2051_Prog5_On(fsd)			clear_s_p23(fsd)
#define _at51_board2051_Prog5_Off(fsd)			set_s_p23(fsd)
#define _at51_board2051_Prog75_On(fsd)			clear_s_p22(fsd)
#define _at51_board2051_Prog75_Off(fsd)			set_s_p22(fsd)
#define _at51_board2051_Prog12_On(fsd)			clear_s_p25(fsd)
#define _at51_board2051_Prog12_Off(fsd)			set_s_p25(fsd)
#define _at51_board2051_SendData(fsd,xdata)		send_m_p1(fsd,xdata)
#define _at51_board2051_ReceiveData(fsd)		receive_m_p1(fsd)
#define _at51_board2051_Set_RDY(fsd)			set_m_p36(fsd)
#define _at51_board2051_Set_31(fsd)			_at51_board2051_Set_RDY(fsd)
#define _at51_board2051_Set_PROG(fsd)			set_s_p10(fsd)
#define _at51_board2051_Set_32(fsd)			_at51_board2051_Set_PROG(fsd)
#define _at51_board2051_Set_P33(fsd)			set_s_p13(fsd)
#define _at51_board2051_Set_P34(fsd)			set_s_p12(fsd)
#define _at51_board2051_Set_P35(fsd)			set_s_p15(fsd)
#define _at51_board2051_Set_P37(fsd)			set_s_p14(fsd)
#define _at51_board2051_Set_XTAL(fsd)			set_s_p11(fsd)
#define _at51_board2051_Clear_RDY(fsd)			clear_m_p36(fsd)
#define _at51_board2051_Clear_31(fsd)			_at51_board2051_Clear_RDY(fsd)
#define _at51_board2051_Clear_PROG(fsd)			clear_s_p10(fsd)
#define _at51_board2051_Clear_32(fsd)			_at51_board2051_Clear_PROG(fsd)
#define _at51_board2051_Clear_P33(fsd)			clear_s_p13(fsd)
#define _at51_board2051_Clear_P34(fsd)			clear_s_p12(fsd)
#define _at51_board2051_Clear_P35(fsd)			clear_s_p15(fsd)
#define _at51_board2051_Clear_P37(fsd)			clear_s_p14(fsd)
#define _at51_board2051_Clear_XTAL(fsd)			clear_s_p11(fsd)
#define _at51_board2051_Get_RDY(fsd)			get_m_p36(fsd)
#define _at51_board2051_Get_31(fsd)			_at51_board2051_Get_RDY(fsd)

void at51_board2051_ActivityLED_On(int fsd);
void at51_board2051_ActivityLED_Off(int fsd);
void at51_board2051_Power33_On(int fsd);
void at51_board2051_Power33_Off(int fsd);
void at51_board2051_Power5_On(int fsd);
void at51_board2051_Power5_Off(int fsd);
void at51_board2051_Power65_On(int fsd);
void at51_board2051_Power65_Off(int fsd);
void at51_board2051_Power_Off(int fsd);
void at51_board2051_Prog33_On(int fsd);
void at51_board2051_Prog33_Off(int fsd);
void at51_board2051_Prog5_On(int fsd);
void at51_board2051_Prog5_Off(int fsd);
void at51_board2051_Prog75_On(int fsd);
void at51_board2051_Prog75_Off(int fsd);
void at51_board2051_Prog12_On(int fsd);
void at51_board2051_Prog12_Off(int fsd);
void at51_board2051_Prog_Off(int fsd);
void at51_board2051_SendData(int fsd, unsigned char xdata);
unsigned char at51_board2051_ReceiveData(int fsd);
unsigned char at51_board2051_Get_RDY(int fsd);
unsigned char at51_board2051_Get_P31(int fsd);
void at51_board2051_Send_RDY(int fsd, int xdata);
void at51_board2051_Send_P31(int fsd, int xdata);
void at51_board2051_Send_PROG(int fsd, int xdata);
void at51_board2051_Send_P32(int fsd, int xdata);
void at51_board2051_Send_XTAL(int fsd, int xdata);
void at51_board2051_Send_P33(int fsd, int xdata);
void at51_board2051_Send_P34(int fsd, int xdata);
void at51_board2051_Send_P35(int fsd, int xdata);
void at51_board2051_Send_P37(int fsd, int xdata);

#endif

/* end of b2051pinbind.h */
