/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * b8051pinbind.c	8051 pin binding subLayer
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#include "b8051pinbind.h"

/*---------------------------------------------------------------------------*/
void at51_board8051_ActivityLED_On(int fsd) {
    clear_s_p24(fsd);
}
void at51_board8051_ActivityLED_Off(int fsd) {
    set_s_p24(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Power33_On(int fsd) {
    clear_s_p17(fsd);
}
void at51_board8051_Power33_Off(int fsd) {
    set_s_p17(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Power5_On(int fsd) {
    clear_s_p16(fsd);
}
void at51_board8051_Power5_Off(int fsd) {
    set_s_p16(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Power65_On(int fsd) {
    clear_s_p21(fsd);
}
void at51_board8051_Power65_Off(int fsd) {
    set_s_p21(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Power_Off(int fsd) {
    set_s_p17(fsd);
    set_s_p16(fsd);
    set_s_p21(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Prog33_On(int fsd) {
    clear_s_p20(fsd);
}
void at51_board8051_Prog33_Off(int fsd) {
    set_s_p20(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Prog5_On(int fsd) {
    clear_s_p23(fsd);
}
void at51_board8051_Prog5_Off(int fsd) {
    set_s_p23(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Prog75_On(int fsd) {
    clear_s_p22(fsd);
}
void at51_board8051_Prog75_Off(int fsd) {
    set_s_p22(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Prog12_On(int fsd) {
    clear_s_p25(fsd);
}
void at51_board8051_Prog12_Off(int fsd) {
    set_s_p25(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Prog_Off(int fsd) {
    set_s_p20(fsd);
    set_s_p23(fsd);
    set_s_p22(fsd);
    set_s_p25(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Address(int fsd, int addr) {
    send_m_p0(fsd,addr & 0x000000ff); /* A0-A7 */
    if (addr & 0x00000100) set_m_p22(fsd); /* A8 */
    else clear_m_p22(fsd);
    if (addr & 0x00000200) set_m_p23(fsd); /* A9 */
    else clear_m_p23(fsd);
    if (addr & 0x00000400) set_m_p20(fsd); /* A10 */
    else clear_m_p20(fsd);
    if (addr & 0x00000800) set_m_p21(fsd); /* A11 */
    else clear_m_p21(fsd);
    if (addr & 0x00001000) set_m_p25(fsd); /* A12 */
    else clear_m_p25(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_SendData(int fsd, unsigned char xdata) {
    send_m_p1(fsd,xdata);
}
/*---------------------------------------------------------------------------*/
unsigned char at51_board8051_ReceiveData(int fsd) {
    return receive_m_p1(fsd);
}
/*---------------------------------------------------------------------------*/
unsigned char at51_board8051_Get_RDY(int fsd) {
    return get_m_p35(fsd); // Not working...
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Send_ALE(int fsd, int xdata) {
    if (xdata) set_s_p06(fsd);
    else clear_s_p06(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Send_RST(int fsd, int xdata) {
    if (xdata) set_s_p01(fsd);
    else clear_s_p01(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Send_PSEN(int fsd, int xdata) {
    if (xdata) set_s_p07(fsd);
    else clear_s_p07(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Send_P26(int fsd, int xdata) {
    if (xdata) set_s_p05(fsd);
    else clear_s_p05(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Send_P27(int fsd, int xdata) {
    if (xdata) set_s_p04(fsd);
    else clear_s_p04(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Send_P33(int fsd, int xdata) {
    if (xdata) set_s_p00(fsd);
    else clear_s_p00(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Send_P36(int fsd, int xdata) {
    if (xdata) set_s_p03(fsd);
    else clear_s_p03(fsd);
}
/*---------------------------------------------------------------------------*/
void at51_board8051_Send_P37(int fsd, int xdata) {
    if (xdata) set_s_p02(fsd);
    else clear_s_p02(fsd);
}
/*---------------------------------------------------------------------------*/

/* end of b8051pinbind.c */
