/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * b8051pinbind.h	8051 pin binding subLayer
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

#ifndef _b8051pinbind_h_at51tool
#define _b8051pinbind_h_at51tool

#include "gpios.h"

#define _at51_board8051_ActivityLED_On(fsd)		clear_s_p24(fsd)
#define _at51_board8051_ActivityLED_Off(fsd)		set_s_p24(fsd)
#define _at51_board8051_Power33_On(fsd)			clear_s_p17(fsd)
#define _at51_board8051_Power33_Off(fsd)		set_s_p17(fsd)
#define _at51_board8051_Power5_On(fsd)			clear_s_p16(fsd)
#define _at51_board8051_Power5_Off(fsd)			set_s_p16(fsd)
#define _at51_board8051_Power65_On(fsd)			clear_s_p21(fsd)
#define _at51_board8051_Power65_Off(fsd)		set_s_p21(fsd)
#define _at51_board8051_Prog33_On(fsd)			clear_s_p20(fsd)
#define _at51_board8051_Prog33_Off(fsd)			set_s_p20(fsd)
#define _at51_board8051_Prog5_On(fsd)			clear_s_p23(fsd)
#define _at51_board8051_Prog5_Off(fsd)			set_s_p23(fsd)
#define _at51_board8051_Prog75_On(fsd)			clear_s_p22(fsd)
#define _at51_board8051_Prog75_Off(fsd)			set_s_p22(fsd)
#define _at51_board8051_Prog12_On(fsd)			clear_s_p25(fsd)
#define _at51_board8051_Prog12_Off(fsd)			set_s_p25(fsd)
#define	_at51_board8051_SendData(fsd,xdata)		send_m_p1(fsd,xdata)
#define _at51_board8051_ReceiveData(fsd)		receive_m_p1(fsd)
#define _at51_board8051_SendAddress8(fsd,addr) 		send_m_p0(fsd,addr)
#define _at51_board8051_Set_ALE(fsd)			set_s_p06(fsd)
#define _at51_board8051_Set_RST(fsd)			set_s_p01(fsd)
#define _at51_board8051_Set_PSEN(fsd)			set_s_p07(fsd)
#define _at51_board8051_Set_P26(fsd)			set_s_p05(fsd)
#define _at51_board8051_Set_P27(fsd)			set_s_p04(fsd)
#define _at51_board8051_Set_P33(fsd)			set_s_p00(fsd)
#define _at51_board8051_Set_P36(fsd)			set_s_p03(fsd)
#define _at51_board8051_Set_P37(fsd)			set_s_p02(fsd)
#define _at51_board8051_Clear_ALE(fsd)			clear_s_p06(fsd)
#define _at51_board8051_Clear_RST(fsd)			clear_s_p01(fsd)
#define _at51_board8051_Clear_PSEN(fsd)			clear_s_p07(fsd)
#define _at51_board8051_Clear_P26(fsd)			clear_s_p05(fsd)
#define _at51_board8051_Clear_P27(fsd)			clear_s_p04(fsd)
#define _at51_board8051_Clear_P33(fsd)			clear_s_p00(fsd)
#define _at51_board8051_Clear_P36(fsd)			clear_s_p03(fsd)
#define _at51_board8051_Clear_P37(fsd)			clear_s_p02(fsd)

void at51_board8051_ActivityLED_On(int fsd);
void at51_board8051_ActivityLED_Off(int fsd);
void at51_board8051_Power33_On(int fsd);
void at51_board8051_Power33_Off(int fsd);
void at51_board8051_Power5_On(int fsd);
void at51_board8051_Power5_Off(int fsd);
void at51_board8051_Power65_On(int fsd);
void at51_board8051_Power65_Off(int fsd);
void at51_board8051_Power_Off(int fsd);
void at51_board8051_Prog33_On(int fsd);
void at51_board8051_Prog33_Off(int fsd);
void at51_board8051_Prog5_On(int fsd);
void at51_board8051_Prog5_Off(int fsd);
void at51_board8051_Prog75_On(int fsd);
void at51_board8051_Prog75_Off(int fsd);
void at51_board8051_Prog12_On(int fsd);
void at51_board8051_Prog12_Off(int fsd);
void at51_board8051_Prog_Off(int fsd);
void at51_board8051_Address(int fsd, int addr);
void at51_board8051_SendData(int fsd, unsigned char xdata);
unsigned char at51_board8051_ReceiveData(int fsd);
unsigned char at51_board8051_Get_RDY(int fsd);
void at51_board8051_Send_ALE(int fsd, int xdata);
void at51_board8051_Send_RST(int fsd, int xdata);
void at51_board8051_Send_PSEN(int fsd, int xdata);
void at51_board8051_Send_P26(int fsd, int xdata);
void at51_board8051_Send_P27(int fsd, int xdata);
void at51_board8051_Send_P33(int fsd, int xdata);
void at51_board8051_Send_P36(int fsd, int xdata);
void at51_board8051_Send_P37(int fsd, int xdata);

#endif

/* end of b8051pinbind.h */
