/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * gpios.c		GPIOs subLayer routines
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

/*---------------------------------------------------------------------------*/

/* 

    Note, that all functions listed below havn't control of the incoming data 
    and will block, if there aren't available device.
    
    In At51Programmer the Slave at51fsd doesn't use it's TxD pin, i.e. the 
    Slave device is not bidirectional (Output only). So all Slave functions
    cannot block, if doesn't exists or doesn't responds.
    
 */

/*---------------------------------------------------------------------------*/

#include "gpios.h"
 
/*---------------------------------------------------------------------------*/
extern int set_m_p00(int fsd) {
    unsigned char ch;
    ch = 0x00;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p01(int fsd) {
    unsigned char ch;
    ch = 0x01;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p02(int fsd) {
    unsigned char ch;
    ch = 0x02;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p03(int fsd) {
    unsigned char ch;
    ch = 0x03;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p04(int fsd) {
    unsigned char ch;
    ch = 0x04;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p05(int fsd) {
    unsigned char ch;
    ch = 0x05;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p06(int fsd) {
    unsigned char ch;
    ch = 0x06;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p07(int fsd) {
    unsigned char ch;
    ch = 0x07;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p00(int fsd) {
    unsigned char ch;
    ch = 0x08;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p01(int fsd) {
    unsigned char ch;
    ch = 0x09;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p02(int fsd) {
    unsigned char ch;
    ch = 0x0A;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p03(int fsd) {
    unsigned char ch;
    ch = 0x0B;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p04(int fsd) {
    unsigned char ch;
    ch = 0x0C;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p05(int fsd) {
    unsigned char ch;
    ch = 0x0D;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p06(int fsd) {
    unsigned char ch;
    ch = 0x0E;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p07(int fsd) {
    unsigned char ch;
    ch = 0x0F;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p10(int fsd) {
    unsigned char ch;
    ch = 0x10;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p11(int fsd) {
    unsigned char ch;
    ch = 0x11;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p12(int fsd) {
    unsigned char ch;
    ch = 0x12;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p13(int fsd) {
    unsigned char ch;
    ch = 0x13;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p14(int fsd) {
    unsigned char ch;
    ch = 0x14;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p15(int fsd) {
    unsigned char ch;
    ch = 0x15;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p16(int fsd) {
    unsigned char ch;
    ch = 0x16;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p17(int fsd) {
    unsigned char ch;
    ch = 0x17;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p10(int fsd) {
    unsigned char ch;
    ch = 0x18;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p11(int fsd) {
    unsigned char ch;
    ch = 0x19;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p12(int fsd) {
    unsigned char ch;
    ch = 0x1A;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p13(int fsd) {
    unsigned char ch;
    ch = 0x1B;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p14(int fsd) {
    unsigned char ch;
    ch = 0x1C;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p15(int fsd) {
    unsigned char ch;
    ch = 0x1D;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p16(int fsd) {
    unsigned char ch;
    ch = 0x1E;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p17(int fsd) {
    unsigned char ch;
    ch = 0x1F;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p20(int fsd) {
    unsigned char ch;
    ch = 0x20;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p21(int fsd) {
    unsigned char ch;
    ch = 0x21;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p22(int fsd) {
    unsigned char ch;
    ch = 0x22;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p23(int fsd) {
    unsigned char ch;
    ch = 0x23;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p24(int fsd) {
    unsigned char ch;
    ch = 0x24;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p25(int fsd) {
    unsigned char ch;
    ch = 0x25;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p26(int fsd) {
    unsigned char ch;
    ch = 0x26;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p27(int fsd) {
    unsigned char ch;
    ch = 0x27;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p20(int fsd) {
    unsigned char ch;
    ch = 0x28;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p21(int fsd) {
    unsigned char ch;
    ch = 0x29;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p22(int fsd) {
    unsigned char ch;
    ch = 0x2A;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p23(int fsd) {
    unsigned char ch;
    ch = 0x2B;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p24(int fsd) {
    unsigned char ch;
    ch = 0x2C;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p25(int fsd) {
    unsigned char ch;
    ch = 0x2D;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p26(int fsd) {
    unsigned char ch;
    ch = 0x2E;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p27(int fsd) {
    unsigned char ch;
    ch = 0x2F;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p35(int fsd) {
    unsigned char ch;
    ch = 0x35;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p36(int fsd) {
    unsigned char ch;
    ch = 0x36;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_m_p37(int fsd) {
    unsigned char ch;
    ch = 0x37;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p35(int fsd) {
    unsigned char ch;
    ch = 0x3D;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p36(int fsd) {
    unsigned char ch;
    ch = 0x3E;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_m_p37(int fsd) {
    unsigned char ch;
    ch = 0x3F;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p00(int fsd) {
    unsigned char ch;
    ch = 0x40;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p01(int fsd) {
    unsigned char ch;
    ch = 0x41;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p02(int fsd) {
    unsigned char ch;
    ch = 0x42;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p03(int fsd) {
    unsigned char ch;
    ch = 0x43;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p04(int fsd) {
    unsigned char ch;
    ch = 0x44;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p05(int fsd) {
    unsigned char ch;
    ch = 0x45;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p06(int fsd) {
    unsigned char ch;
    ch = 0x46;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p07(int fsd) {
    unsigned char ch;
    ch = 0x47;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p10(int fsd) {
    unsigned char ch;
    ch = 0x50;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p11(int fsd) {
    unsigned char ch;
    ch = 0x51;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p12(int fsd) {
    unsigned char ch;
    ch = 0x52;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p13(int fsd) {
    unsigned char ch;
    ch = 0x53;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p14(int fsd) {
    unsigned char ch;
    ch = 0x54;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p15(int fsd) {
    unsigned char ch;
    ch = 0x55;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p16(int fsd) {
    unsigned char ch;
    ch = 0x56;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p17(int fsd) {
    unsigned char ch;
    ch = 0x57;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p20(int fsd) {
    unsigned char ch;
    ch = 0x60;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p21(int fsd) {
    unsigned char ch;
    ch = 0x61;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p22(int fsd) {
    unsigned char ch;
    ch = 0x62;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p23(int fsd) {
    unsigned char ch;
    ch = 0x63;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p24(int fsd) {
    unsigned char ch;
    ch = 0x64;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p25(int fsd) {
    unsigned char ch;
    ch = 0x65;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p26(int fsd) {
    unsigned char ch;
    ch = 0x66;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p27(int fsd) {
    unsigned char ch;
    ch = 0x67;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p35(int fsd) {
    unsigned char ch;
    ch = 0x75;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p36(int fsd) {
    unsigned char ch;
    ch = 0x76;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_m_p37(int fsd) {
    unsigned char ch;
    ch = 0x77;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern int send_m_p0(int fsd, unsigned char xdata) {
    unsigned char ch;
    ch = 0x48;
    write (fsd,&ch,1);
    write (fsd,&xdata,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int send_m_p1(int fsd, unsigned char xdata) {
    unsigned char ch;
    ch = 0x58;
    write (fsd,&ch,1);
    write (fsd,&xdata,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int send_m_p2(int fsd, unsigned char xdata) {
    unsigned char ch;
    ch = 0x68;
    write (fsd,&ch,1);
    write (fsd,&xdata,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern unsigned char receive_m_p0(int fsd) {
    unsigned char ch;
    ch = 0x49;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char receive_m_p1(int fsd) {
    unsigned char ch;
    ch = 0x59;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char receive_m_p2(int fsd) {
    unsigned char ch;
    ch = 0x69;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p00(int fsd) {
    unsigned char ch;
    ch = 0x80;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p01(int fsd) {
    unsigned char ch;
    ch = 0x81;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p02(int fsd) {
    unsigned char ch;
    ch = 0x82;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p03(int fsd) {
    unsigned char ch;
    ch = 0x83;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p04(int fsd) {
    unsigned char ch;
    ch = 0x84;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p05(int fsd) {
    unsigned char ch;
    ch = 0x85;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p06(int fsd) {
    unsigned char ch;
    ch = 0x86;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p07(int fsd) {
    unsigned char ch;
    ch = 0x87;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p00(int fsd) {
    unsigned char ch;
    ch = 0x88;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p01(int fsd) {
    unsigned char ch;
    ch = 0x89;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p02(int fsd) {
    unsigned char ch;
    ch = 0x8A;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p03(int fsd) {
    unsigned char ch;
    ch = 0x8B;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p04(int fsd) {
    unsigned char ch;
    ch = 0x8C;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p05(int fsd) {
    unsigned char ch;
    ch = 0x8D;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p06(int fsd) {
    unsigned char ch;
    ch = 0x8E;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p07(int fsd) {
    unsigned char ch;
    ch = 0x8F;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p10(int fsd) {
    unsigned char ch;
    ch = 0x90;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p11(int fsd) {
    unsigned char ch;
    ch = 0x91;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p12(int fsd) {
    unsigned char ch;
    ch = 0x92;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p13(int fsd) {
    unsigned char ch;
    ch = 0x93;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p14(int fsd) {
    unsigned char ch;
    ch = 0x94;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p15(int fsd) {
    unsigned char ch;
    ch = 0x95;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p16(int fsd) {
    unsigned char ch;
    ch = 0x96;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p17(int fsd) {
    unsigned char ch;
    ch = 0x97;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p10(int fsd) {
    unsigned char ch;
    ch = 0x98;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p11(int fsd) {
    unsigned char ch;
    ch = 0x99;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p12(int fsd) {
    unsigned char ch;
    ch = 0x9A;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p13(int fsd) {
    unsigned char ch;
    ch = 0x9B;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p14(int fsd) {
    unsigned char ch;
    ch = 0x9C;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p15(int fsd) {
    unsigned char ch;
    ch = 0x9D;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p16(int fsd) {
    unsigned char ch;
    ch = 0x9E;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p17(int fsd) {
    unsigned char ch;
    ch = 0x9F;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p20(int fsd) {
    unsigned char ch;
    ch = 0xA0;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p21(int fsd) {
    unsigned char ch;
    ch = 0xA1;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p22(int fsd) {
    unsigned char ch;
    ch = 0xA2;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p23(int fsd) {
    unsigned char ch;
    ch = 0xA3;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p24(int fsd) {
    unsigned char ch;
    ch = 0xA4;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p25(int fsd) {
    unsigned char ch;
    ch = 0xA5;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p26(int fsd) {
    unsigned char ch;
    ch = 0xA6;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p27(int fsd) {
    unsigned char ch;
    ch = 0xA7;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p20(int fsd) {
    unsigned char ch;
    ch = 0xA8;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p21(int fsd) {
    unsigned char ch;
    ch = 0xA9;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p22(int fsd) {
    unsigned char ch;
    ch = 0xAA;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p23(int fsd) {
    unsigned char ch;
    ch = 0xAB;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p24(int fsd) {
    unsigned char ch;
    ch = 0xAC;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p25(int fsd) {
    unsigned char ch;
    ch = 0xAD;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p26(int fsd) {
    unsigned char ch;
    ch = 0xAE;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p27(int fsd) {
    unsigned char ch;
    ch = 0xAF;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p35(int fsd) {
    unsigned char ch;
    ch = 0xB5;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p36(int fsd) {
    unsigned char ch;
    ch = 0xB6;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int set_s_p37(int fsd) {
    unsigned char ch;
    ch = 0xB7;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p35(int fsd) {
    unsigned char ch;
    ch = 0xBD;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p36(int fsd) {
    unsigned char ch;
    ch = 0xBE;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int clear_s_p37(int fsd) {
    unsigned char ch;
    ch = 0xBF;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p00(int fsd) {
    unsigned char ch;
    ch = 0xC0;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p01(int fsd) {
    unsigned char ch;
    ch = 0xC1;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p02(int fsd) {
    unsigned char ch;
    ch = 0xC2;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p03(int fsd) {
    unsigned char ch;
    ch = 0xC3;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p04(int fsd) {
    unsigned char ch;
    ch = 0xC4;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p05(int fsd) {
    unsigned char ch;
    ch = 0xC5;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p06(int fsd) {
    unsigned char ch;
    ch = 0xC6;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p07(int fsd) {
    unsigned char ch;
    ch = 0xC7;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p10(int fsd) {
    unsigned char ch;
    ch = 0xD0;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p11(int fsd) {
    unsigned char ch;
    ch = 0xD1;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p12(int fsd) {
    unsigned char ch;
    ch = 0xD2;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p13(int fsd) {
    unsigned char ch;
    ch = 0xD3;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p14(int fsd) {
    unsigned char ch;
    ch = 0xD4;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p15(int fsd) {
    unsigned char ch;
    ch = 0xD5;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p16(int fsd) {
    unsigned char ch;
    ch = 0xD6;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p17(int fsd) {
    unsigned char ch;
    ch = 0xD7;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p20(int fsd) {
    unsigned char ch;
    ch = 0xE0;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p21(int fsd) {
    unsigned char ch;
    ch = 0xE1;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p22(int fsd) {
    unsigned char ch;
    ch = 0xE2;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p23(int fsd) {
    unsigned char ch;
    ch = 0xE3;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p24(int fsd) {
    unsigned char ch;
    ch = 0xE4;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p25(int fsd) {
    unsigned char ch;
    ch = 0xE5;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p26(int fsd) {
    unsigned char ch;
    ch = 0xE6;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p27(int fsd) {
    unsigned char ch;
    ch = 0xE7;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p35(int fsd) {
    unsigned char ch;
    ch = 0xF5;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p36(int fsd) {
    unsigned char ch;
    ch = 0xF6;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char get_s_p37(int fsd) {
    unsigned char ch;
    ch = 0xF7;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern int send_s_p0(int fsd, unsigned char xdata) {
    unsigned char ch;
    ch = 0xC8;
    write (fsd,&ch,1);
    write (fsd,&xdata,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int send_s_p1(int fsd, unsigned char xdata) {
    unsigned char ch;
    ch = 0xD8;
    write (fsd,&ch,1);
    write (fsd,&xdata,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int send_s_p2(int fsd, unsigned char xdata) {
    unsigned char ch;
    ch = 0xE8;
    write (fsd,&ch,1);
    write (fsd,&xdata,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern unsigned char receive_s_p0(int fsd) {
    unsigned char ch;
    ch = 0xC9;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char receive_s_p1(int fsd) {
    unsigned char ch;
    ch = 0xD9;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern unsigned char receive_s_p2(int fsd) {
    unsigned char ch;
    ch = 0xE9;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return ch;
}
/*---------------------------------------------------------------------------*/
extern int dummy_m(int fsd) {
    unsigned char ch;
    ch = 0x7D;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int dummy_s(int fsd) {
    unsigned char ch;
    ch = 0xFD;
    write (fsd,&ch,1);
//    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int enable_communication(int fsd) {
    unsigned char ch;
    ch = 0x7E;
    write (fsd,&ch,1);
    ch = 0x68;
    write (fsd,&ch,1);
    ch = 0x79;
    write (fsd,&ch,1);
    ch = 0x70;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    read (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/
extern int disable_communication(int fsd) {
    unsigned char ch;
    ch = 0xFE;
    write (fsd,&ch,1);
    ch = 0x68;
    write (fsd,&ch,1);
    ch = 0x79;
    write (fsd,&ch,1);
    ch = 0x70;
    write (fsd,&ch,1);
    read (fsd,&ch,1);
    read (fsd,&ch,1);
    read (fsd,&ch,1);
    return 0;
}
/*---------------------------------------------------------------------------*/

/* end of gpios.c */
