/*
 * at51programmer       Programmer for Atmel 8051 devices, Parallel Flash and
 *                      E2Prom memories.
 *
 * gpios.h		GPIOs subLayer routines
 *
 * Copyright (C) 2004, Petar T. Petkoff
 *
 * Petar T. Petkoff <tihomiroff@yahoo.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License version 2
 */

/*
    Pay Attention!
			Pay Attention!
					    Pay Attention!
    
	Note that, in AT51Programmer the Slave device is OUTPUT ONLY DEVICE, 
    so all functions, which looks like "get_s_p" or "receive_s_p" will not 
    work in this project (without hardware changes). These functions are 
    written for compatibility only.
	If you want, you can use Master and Slave devices for your own 
    project and than you can use these functions. See and read the LICENSE,
    if you didn't!
    
 */

#ifndef _gpios_h_at51tool
#define _gpios_h_at51tool

#include <unistd.h>

extern int set_m_p00(int fsd);
extern int set_m_p01(int fsd);
extern int set_m_p02(int fsd);
extern int set_m_p03(int fsd);
extern int set_m_p04(int fsd);
extern int set_m_p05(int fsd);
extern int set_m_p06(int fsd);
extern int set_m_p07(int fsd);
extern int set_m_p10(int fsd);
extern int set_m_p11(int fsd);
extern int set_m_p12(int fsd);
extern int set_m_p13(int fsd);
extern int set_m_p14(int fsd);
extern int set_m_p15(int fsd);
extern int set_m_p16(int fsd);
extern int set_m_p17(int fsd);
extern int set_m_p20(int fsd);
extern int set_m_p21(int fsd);
extern int set_m_p22(int fsd);
extern int set_m_p23(int fsd);
extern int set_m_p24(int fsd);
extern int set_m_p25(int fsd);
extern int set_m_p26(int fsd);
extern int set_m_p27(int fsd);
extern int set_m_p35(int fsd);
extern int set_m_p36(int fsd);
extern int set_m_p37(int fsd);
extern int clear_m_p00(int fsd);
extern int clear_m_p01(int fsd);
extern int clear_m_p02(int fsd);
extern int clear_m_p03(int fsd);
extern int clear_m_p04(int fsd);
extern int clear_m_p05(int fsd);
extern int clear_m_p06(int fsd);
extern int clear_m_p07(int fsd);
extern int clear_m_p10(int fsd);
extern int clear_m_p11(int fsd);
extern int clear_m_p12(int fsd);
extern int clear_m_p13(int fsd);
extern int clear_m_p14(int fsd);
extern int clear_m_p15(int fsd);
extern int clear_m_p16(int fsd);
extern int clear_m_p17(int fsd);
extern int clear_m_p20(int fsd);
extern int clear_m_p21(int fsd);
extern int clear_m_p22(int fsd);
extern int clear_m_p23(int fsd);
extern int clear_m_p24(int fsd);
extern int clear_m_p25(int fsd);
extern int clear_m_p26(int fsd);
extern int clear_m_p27(int fsd);
extern int clear_m_p35(int fsd);
extern int clear_m_p36(int fsd);
extern int clear_m_p37(int fsd);
extern unsigned char get_m_p00(int fsd);
extern unsigned char get_m_p01(int fsd);
extern unsigned char get_m_p02(int fsd);
extern unsigned char get_m_p03(int fsd);
extern unsigned char get_m_p04(int fsd);
extern unsigned char get_m_p05(int fsd);
extern unsigned char get_m_p06(int fsd);
extern unsigned char get_m_p07(int fsd);
extern unsigned char get_m_p10(int fsd);
extern unsigned char get_m_p11(int fsd);
extern unsigned char get_m_p12(int fsd);
extern unsigned char get_m_p13(int fsd);
extern unsigned char get_m_p14(int fsd);
extern unsigned char get_m_p15(int fsd);
extern unsigned char get_m_p16(int fsd);
extern unsigned char get_m_p17(int fsd);
extern unsigned char get_m_p20(int fsd);
extern unsigned char get_m_p21(int fsd);
extern unsigned char get_m_p22(int fsd);
extern unsigned char get_m_p23(int fsd);
extern unsigned char get_m_p24(int fsd);
extern unsigned char get_m_p25(int fsd);
extern unsigned char get_m_p26(int fsd);
extern unsigned char get_m_p27(int fsd);
extern unsigned char get_m_p35(int fsd);
extern unsigned char get_m_p36(int fsd);
extern unsigned char get_m_p37(int fsd);
extern int send_m_p0(int fsd, unsigned char xdata);
extern int send_m_p1(int fsd, unsigned char xdata);
extern int send_m_p2(int fsd, unsigned char xdata);
extern unsigned char receive_m_p0(int fsd);
extern unsigned char receive_m_p1(int fsd);
extern unsigned char receive_m_p2(int fsd);
extern int set_s_p00(int fsd);
extern int set_s_p01(int fsd);
extern int set_s_p02(int fsd);
extern int set_s_p03(int fsd);
extern int set_s_p04(int fsd);
extern int set_s_p05(int fsd);
extern int set_s_p06(int fsd);
extern int set_s_p07(int fsd);
extern int set_s_p10(int fsd);
extern int set_s_p11(int fsd);
extern int set_s_p12(int fsd);
extern int set_s_p13(int fsd);
extern int set_s_p14(int fsd);
extern int set_s_p15(int fsd);
extern int set_s_p16(int fsd);
extern int set_s_p17(int fsd);
extern int set_s_p20(int fsd);
extern int set_s_p21(int fsd);
extern int set_s_p22(int fsd);
extern int set_s_p23(int fsd);
extern int set_s_p24(int fsd);
extern int set_s_p25(int fsd);
extern int set_s_p26(int fsd);
extern int set_s_p27(int fsd);
extern int set_s_p35(int fsd);
extern int set_s_p36(int fsd);
extern int set_s_p37(int fsd);
extern int clear_s_p00(int fsd);
extern int clear_s_p01(int fsd);
extern int clear_s_p02(int fsd);
extern int clear_s_p03(int fsd);
extern int clear_s_p04(int fsd);
extern int clear_s_p05(int fsd);
extern int clear_s_p06(int fsd);
extern int clear_s_p07(int fsd);
extern int clear_s_p10(int fsd);
extern int clear_s_p11(int fsd);
extern int clear_s_p12(int fsd);
extern int clear_s_p13(int fsd);
extern int clear_s_p14(int fsd);
extern int clear_s_p15(int fsd);
extern int clear_s_p16(int fsd);
extern int clear_s_p17(int fsd);
extern int clear_s_p20(int fsd);
extern int clear_s_p21(int fsd);
extern int clear_s_p22(int fsd);
extern int clear_s_p23(int fsd);
extern int clear_s_p24(int fsd);
extern int clear_s_p25(int fsd);
extern int clear_s_p26(int fsd);
extern int clear_s_p27(int fsd);
extern int clear_s_p35(int fsd);
extern int clear_s_p36(int fsd);
extern int clear_s_p37(int fsd);
extern unsigned char get_s_p00(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p01(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p02(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p03(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p04(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p05(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p06(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p07(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p10(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p11(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p12(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p13(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p14(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p15(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p16(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p17(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p20(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p21(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p22(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p23(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p24(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p25(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p26(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p27(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p35(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p36(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char get_s_p37(int fsd); /* Doesn't work in AT51Programmer */
extern int send_s_p0(int fsd, unsigned char xdata);
extern int send_s_p1(int fsd, unsigned char xdata);
extern int send_s_p2(int fsd, unsigned char xdata);
extern unsigned char receive_s_p0(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char receive_s_p1(int fsd); /* Doesn't work in AT51Programmer */
extern unsigned char receive_s_p2(int fsd); /* Doesn't work in AT51Programmer */
extern int dummy_m(int fsd);
extern int dummy_s(int fsd);
extern int enable_communication(int fsd);
extern int disable_communication(int fsd);

#endif

/* end of gpios.h */
